/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function LatestMapGuaranteeTask(arg)
{
    ttTask.apply(this, arguments);
}
LatestMapGuaranteeTask.prototype =
{
    name : "LatestMapGuarantee",

    start : function (params)
    {
        ttTask.prototype.start.apply(this, arguments);
        this.addCleanupHandler(function(task, success, data)
        {
            if (success)
            {
                runAsync(function(){ top.MapSubscription.offerMapSubscriptionDeal(true, "lmg"); });
            }
        });

        if (params && params.cleanupHandler)
            this.addCleanupHandler(params.cleanupHandler);

        this.loadSubTask(new LatestMapGuarantee(params), null,
            makeCallback(this, this.lmgDone)
            );
    },

    lmgDone : function (data)
    {
        if (data.doUpdate)
            this.installLoad(data.mapsToUpdate);
        else
            this.taskDone();
    },

    installLoad : function (items)
    {
        this.loadSubTask(new InstallSelectSome(),
            { items: items,
              confirmSelection: true,
              hideInstallLater: true },
            makeCallback(this, this.installDone)
            );
    },

    installDone : function (data)
    {
        try {
            prefService().setBoolPref("tomtom.app.lmg_process_done", true);
        } catch (e) { unimportantError(e); }

        this.taskDone();
    },

    __end : null
}
extend(LatestMapGuaranteeTask, ttTask);
var task = new LatestMapGuaranteeTask();
