/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ShowCart()
{
    ttPage.apply(this, arguments);
}
ShowCart.prototype =
{
    _sb : null,

    inputOnLoad : function (data)
    {
        this._sb = E("cart-stringbundle");
        var listbox = E("listbox");
        listbox.addObserver(this);

        var itemList = new ttItemList();
        itemList.addFilter(new ttDependencyTreeBuilder());
        listbox.addItemList(itemList);

        var contents = gApplication.cart.contentsFlat;
        for (var i = 0; i < contents.length; i++)
        {
            itemList.addItem(contents[i]);
        }

        setTermsAndConditionsLink(E("readTermsConditionsLink"), this._sb);

        if (gApplication.settings.country.toLowerCase() == "us")
        {
            E("texasConnecticutVAT").hidden = false;
        }

        refresh();
        this._wizard().removeAttribute("contenttype");
        this._wizard().className = "trolley";
    },

    addedListItem : function (listItem)
    {
        listItem.addButton(this._sb.getString("RemoveButton"), remove);
    },

    cancelShopping : function ()
    {
        if(!gApplication.cart.isEmpty)
        {
            var me = this;
            var mgs = new MessageService();
            mgs.confirm(this._sb.getString("cancelShopping"),
                        this._sb.getString("cancelShoppingMsg"),
                        null,
                        null,
                        makeCallback(me, me.emptyCartAndExit),
                        null);
        } 
        else
        {
            this._wizard().goHome(true);
        }
    },

    emptyCartAndExit : function()
    {
        gApplication.cart.clear();
        this._wizard().goHome(true);
    },

    __end : null
}
extend(ShowCart, ttPage);
window.page = new ShowCart();

function add(listitem)
{
    gApplication.cart.addItem(listitem.modelitem);
    refresh();
}
function remove(listitem)
{
    removeItem(listitem.modelitem, E("listbox"));
    window.page.allowContinue(!gApplication.cart.isEmpty);
    refresh();
}
function removeItem(modelitem, listbox)
{
    gApplication.cart.removeItem(modelitem);
    listbox.removeModel(modelitem);
    var clonedList = gApplication.cart.contentsFlat.slice();
    for each (var item in clonedList)
    {
        for each (var dependency in item.dependencies)
        {
            if (dependency.matches(modelitem))
            {
                removeItem(item, listbox);
                break;
            }
        }
    }
}
function refresh()
{
    E("total-amount").value = gApplication.cart.totalPrice.displayString();
    E("downloadWithBroadband").hidden = (gApplication.cart.totalSize < 20971520);
}
